#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"

#include <curl/curl.h>


using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data(istream& stream) {
    Input in;
    size_t number_count;
    stream >> number_count;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        stream >> in.numbers[i];
    }
    stream >> in.bin_count;
    return in;
}

int main(int argc, char* argv[]) {
    if (argc > 1) {
            CURL* curl = curl_easy_init();
            auto res = curl_easy_perform(curl);
            if (res != 0) {
                cout << curl_easy_strerror(res);
                exit(1);
            }
            curl_easy_cleanup(curl);
            return 0;
    }
    Input in = input_data(cin);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins);
    return 0;
}